diff --git a/src/netinfo_priv.h b/src/netinfo_priv.h
index 3f764566b..afbc4f6ce 100644
--- a/src/netinfo_priv.h
+++ b/src/netinfo_priv.h
@@ -64,7 +64,8 @@ extern ni_bool_t	ni_netconfig_discover_filtered(ni_netconfig_t *, unsigned int);
 extern ni_bool_t	ni_netconfig_set_family_filter(ni_netconfig_t *, unsigned int);
 extern unsigned int	ni_netconfig_get_family_filter(ni_netconfig_t *);
 
-extern ni_bool_t	__ni_linkinfo_kind_to_type(const char *, ni_iftype_t *);
+extern ni_bool_t	ni_linkinfo_kind_to_type(const char *, ni_iftype_t *);
+extern const char *	ni_linkinfo_type_to_kind(ni_iftype_t);
 
 extern void		__ni_netdev_list_append(ni_netdev_t **, ni_netdev_t *);
 extern void		__ni_netdev_list_destroy(ni_netdev_t **);
@@ -256,16 +257,4 @@ extern void				ni_arp_notify_destroy(ni_arp_notify_t *);
 extern unsigned int			ni_arp_notify_add_address(ni_arp_notify_t *,  ni_address_t *);
 extern ni_bool_t			ni_arp_notify_send(ni_arp_socket_t *, ni_arp_notify_t *, ni_timeout_t *);
 
-/* netdev reques port config */
-struct ni_netdev_port_req {
-	ni_iftype_t				type;
-	union {
-		ni_team_port_config_t		team;
-		ni_ovs_bridge_port_config_t	ovsbr;
-	};
-};
-
-extern ni_netdev_port_req_t *	ni_netdev_port_req_new(ni_iftype_t);
-extern void			ni_netdev_port_req_free(ni_netdev_port_req_t *);
-
 #endif /* __NETINFO_PRIV_H__ */
diff --git a/src/ovs.c b/src/ovs.c
index 6b3395b15..9164f7023 100644
--- a/src/ovs.c
+++ b/src/ovs.c
@@ -1,7 +1,7 @@
 /*
  *	OVS (bridge) device support
  *
- *	Copyright (C) 2015 SUSE Linux GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2015-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,13 +13,8 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Marius Tomaschewski <mt@suse.de>
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifdef HAVE_CONFIG_H
 #include "config.h"
@@ -35,7 +30,6 @@
 #include "util_priv.h"
 #include "array_priv.h"
 
-#define NI_OVS_BRIDGE_PORT_ARRAY_CHUNK		4
 
 ni_ovs_bridge_t *
 ni_ovs_bridge_new(void)
@@ -52,7 +46,6 @@ ni_ovs_bridge_free(ni_ovs_bridge_t *ovsbr)
 {
 	if (ovsbr) {
 		ni_ovs_bridge_config_destroy(&ovsbr->config);
-		ni_ovs_bridge_port_array_destroy(&ovsbr->ports);
 		free(ovsbr);
 	}
 }
@@ -70,84 +63,51 @@ ni_ovs_bridge_config_destroy(ni_ovs_bridge_config_t *conf)
 	ni_ovs_bridge_config_init(conf);
 }
 
-
-ni_ovs_bridge_port_t *
-ni_ovs_bridge_port_new(void)
-{
-	ni_ovs_bridge_port_t *port;
-
-	port = xcalloc(1, sizeof(*port));
-	return port;
-}
-
-void
-ni_ovs_bridge_port_free(ni_ovs_bridge_port_t *port)
+/*
+ * OVS bridge port config
+ */
+ni_bool_t
+ni_ovs_bridge_port_config_init(ni_ovs_bridge_port_config_t *conf)
 {
-	if (port) {
-		ni_netdev_ref_destroy(&port->device);
-		free(port);
+	if (conf) {
+		memset(conf, 0, sizeof(*conf));
+		return TRUE;
 	}
+	return FALSE;
 }
 
-extern ni_define_ptr_array_init(ni_ovs_bridge_port);
-extern ni_define_ptr_array_destroy(ni_ovs_bridge_port);
-static ni_define_ptr_array_realloc(ni_ovs_bridge_port, NI_OVS_BRIDGE_PORT_ARRAY_CHUNK);
-extern ni_define_ptr_array_append(ni_ovs_bridge_port);
-extern ni_define_ptr_array_delete_at(ni_ovs_bridge_port);
-
-ni_ovs_bridge_port_t *
-ni_ovs_bridge_port_array_add_new(ni_ovs_bridge_port_array_t *ports, const char *pname)
+ni_ovs_bridge_port_config_t *
+ni_ovs_bridge_port_config_new(void)
 {
-	ni_ovs_bridge_port_t *port;
-
-	if (!ports || ni_string_empty(pname))
-		return NULL;
-
-	if (ni_ovs_bridge_port_array_find_by_name(ports, pname))
-		return NULL;
-
-	if (!(port = ni_ovs_bridge_port_new()))
-		return NULL;
-
-	ni_netdev_ref_set_ifname(&port->device, pname);
+	ni_ovs_bridge_port_config_t *conf;
 
-	if (ni_ovs_bridge_port_array_append(ports, port))
-		return port;
+	conf = malloc(sizeof(*conf));
+	if (ni_ovs_bridge_port_config_init(conf))
+		return conf;
 
-	ni_ovs_bridge_port_free(port);
-	return NULL;
-}
-
-ni_ovs_bridge_port_t *
-ni_ovs_bridge_port_array_find_by_name(ni_ovs_bridge_port_array_t *array, const char *name)
-{
-	unsigned int i;
-
-	if (!array || !name)
-		return NULL;
-
-	for (i = 0; i < array->count; ++i) {
-		ni_ovs_bridge_port_t *port = array->data[i];
-		if (ni_string_eq(name, port->device.name))
-			return port;
-	}
+	free(conf);
 	return NULL;
 }
 
 void
-ni_ovs_bridge_port_config_init(ni_ovs_bridge_port_config_t *conf)
+ni_ovs_bridge_port_config_destroy(ni_ovs_bridge_port_config_t *conf)
 {
-	memset(conf, 0, sizeof(*conf));
+	if (conf) {
+		ni_var_array_destroy(&conf->args);
+		ni_ovs_bridge_port_config_init(conf);
+	}
 }
 
+/*
+ * OVS bridge port state info
+ */
 void
-ni_ovs_bridge_port_config_destroy(ni_ovs_bridge_port_config_t *conf)
+ni_ovs_bridge_port_config_free(ni_ovs_bridge_port_config_t *conf)
 {
-	ni_netdev_ref_destroy(&conf->bridge);
-	ni_ovs_bridge_port_config_init(conf);
+	ni_ovs_bridge_port_config_destroy(conf);
+	free(conf);
 }
 
-
 static const char *
 ni_ovs_vsctl_tool_path(void)
 {
@@ -320,7 +280,7 @@ failure:
 
 
 int /* process run codes (for now) */
-ni_ovs_vsctl_bridge_ports(const char *brname, ni_ovs_bridge_port_array_t *ports)
+ni_ovs_vsctl_bridge_ports(const char *brname, ni_netdev_ref_array_t *ports)
 {
 	ni_stringbuf_t pname = NI_STRINGBUF_INIT_DYNAMIC;
 	const char *ovs_vsctl;
@@ -364,7 +324,7 @@ ni_ovs_vsctl_bridge_ports(const char *brname, ni_ovs_bridge_port_array_t *ports)
 		if (cc == '\n') {
 			if (pname.string)
 				pname.string[strcspn(pname.string, "\n\r")] = '\0';
-			ni_ovs_bridge_port_array_add_new(ports, pname.string);
+			ni_netdev_ref_array_append(ports, pname.string, 0);
 			ni_stringbuf_destroy(&pname);
 		} else {
 			ni_stringbuf_putc(&pname, cc);
@@ -372,7 +332,7 @@ ni_ovs_vsctl_bridge_ports(const char *brname, ni_ovs_bridge_port_array_t *ports)
 	}
 	if (pname.string)
 		pname.string[strcspn(pname.string, "\n\r")] = '\0';
-	ni_ovs_bridge_port_array_add_new(ports, pname.string);
+	ni_netdev_ref_array_append(ports, pname.string, 0);
 	ni_stringbuf_destroy(&pname);
 
 failure:
@@ -476,14 +436,16 @@ failure:
 }
 
 int /* process run codes (for now) */
-ni_ovs_vsctl_bridge_port_add(const char *pname, const ni_ovs_bridge_port_config_t *pconf, ni_bool_t may_exist)
+ni_ovs_vsctl_bridge_port_add(const char *brname, const char *pname,
+		const ni_ovs_bridge_port_config_t *pconf,
+		ni_bool_t may_exist)
 {
 	const char *ovs_vsctl;
 	ni_shellcmd_t *cmd;
 	ni_process_t *pi;
 	int rv = NI_PROCESS_FAILURE;
 
-	if (ni_string_empty(pname) || !pconf || ni_string_empty(pconf->bridge.name))
+	if (ni_string_empty(brname) || ni_string_empty(pname) || !pconf)
 		return rv;
 
 	if (!(ovs_vsctl = ni_ovs_vsctl_tool_path()))
@@ -501,7 +463,7 @@ ni_ovs_vsctl_bridge_port_add(const char *pname, const ni_ovs_bridge_port_config_
 	if (!ni_shellcmd_add_arg(cmd, "add-port"))
 		goto failure;
 
-	if (!ni_shellcmd_add_arg(cmd, pconf->bridge.name))
+	if (!ni_shellcmd_add_arg(cmd, brname))
 		goto failure;
 
 	if (!ni_shellcmd_add_arg(cmd, pname))
@@ -598,7 +560,7 @@ ni_ovs_vsctl_bridge_port_to_bridge(const char *pname, char **brname)
 
 	rv = ni_process_run_and_capture_output(pi, &buf);
 	ni_process_free(pi);
-	if (rv) {
+	if (rv != NI_PROCESS_SUCCESS) {
 		ni_error("%s: unable to query port bridge", pname);
 		goto failure;
 	}
@@ -619,30 +581,69 @@ int
 ni_ovs_bridge_discover(ni_netdev_t *dev, ni_netconfig_t *nc)
 {
 	ni_ovs_bridge_t *ovsbr;
-	unsigned int i;
 
 	if (!dev || dev->link.type != NI_IFTYPE_OVS_BRIDGE)
 		return -1;
 
 	ovsbr = ni_ovs_bridge_new();
 	if (ni_ovs_vsctl_bridge_to_parent(dev->name, &ovsbr->config.vlan.parent.name) ||
-	    ni_ovs_vsctl_bridge_to_vlan(dev->name, &ovsbr->config.vlan.tag) ||
-	    ni_ovs_vsctl_bridge_ports(dev->name, &ovsbr->ports)) {
+	    ni_ovs_vsctl_bridge_to_vlan(dev->name, &ovsbr->config.vlan.tag)) {
 		ni_ovs_bridge_free(ovsbr);
 		return -1;
 	}
 
-	if (nc) {
-		if (ovsbr->config.vlan.parent.name)
-			ni_netdev_ref_bind_ifindex(&ovsbr->config.vlan.parent, nc);
+	if (ovsbr->config.vlan.parent.name)
+		ni_netdev_ref_bind_ifindex(&ovsbr->config.vlan.parent, nc);
 
-		for (i = 0; i < ovsbr->ports.count;  ++i) {
-			ni_ovs_bridge_port_t *port = ovsbr->ports.data[i];
-			if (port->device.name)
-				ni_netdev_ref_bind_ifindex(&port->device, nc);
-		}
-	}
 	ni_netdev_set_ovs_bridge(dev, ovsbr);
 	return 0;
 }
 
+int
+ni_ovs_port_info_discover(ni_netdev_port_info_t *port, const char *name,
+		ni_netconfig_t *nc)
+{
+	char *bridge = NULL;
+	int rv;
+
+	if (!port || ni_string_empty(name))
+		return -1;
+
+	rv = ni_ovs_vsctl_bridge_port_to_bridge(name, &bridge);
+	if (rv == NI_PROCESS_SUCCESS && !ni_string_empty(bridge)) {
+
+		ni_netdev_port_info_data_destroy(port);
+		if (!ni_netdev_port_info_data_init(port, NI_IFTYPE_OVS_BRIDGE))
+			goto failure;
+
+		ni_string_move(&port->ovsbr->bridge.name, &bridge);
+
+		/* we may not be able to find bridge index while
+		 * initial interface fetch at start/bootstrap. */
+		ni_netdev_ref_bind_ifindex(&port->ovsbr->bridge, nc);
+		return 0;
+	}
+
+failure:
+	ni_string_free(&bridge);
+	return -1;
+}
+
+ni_ovs_bridge_port_info_t *
+ni_ovs_bridge_port_info_new(void)
+{
+	ni_ovs_bridge_port_info_t *info;
+
+	info = calloc(1, sizeof(*info));
+	return info;
+}
+
+void
+ni_ovs_bridge_port_info_free(ni_ovs_bridge_port_info_t *info)
+{
+	if (info) {
+		ni_netdev_ref_destroy(&info->bridge);
+		free(info);
+	}
+}
+
diff --git a/src/ovs.h b/src/ovs.h
index c7f37cc0e..62b7c63d5 100644
--- a/src/ovs.h
+++ b/src/ovs.h
@@ -1,7 +1,7 @@
 /*
  *	OVS (bridge) device ctl operations
  *
- *	Copyright (C) 2015 SUSE Linux GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2015-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,13 +13,8 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Marius Tomaschewski <mt@suse.de>
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifndef NI_WICKED_OVS_CTL_H
 #define NI_WICKED_OVS_CTL_H
@@ -32,13 +27,15 @@ extern int	ni_ovs_vsctl_bridge_del(const char *);
 extern int	ni_ovs_vsctl_bridge_exists(const char *);
 extern int	ni_ovs_vsctl_bridge_to_vlan(const char *, uint16_t *);
 extern int	ni_ovs_vsctl_bridge_to_parent(const char *, char **);
-extern int	ni_ovs_vsctl_bridge_ports(const char *, ni_ovs_bridge_port_array_t *);
+extern int	ni_ovs_vsctl_bridge_ports(const char *, ni_netdev_ref_array_t *);
 
-extern int	ni_ovs_vsctl_bridge_port_add(const char *, const ni_ovs_bridge_port_config_t *,
-							ni_bool_t);
+extern int	ni_ovs_vsctl_bridge_port_add(const char *, const char *,
+				const ni_ovs_bridge_port_config_t *, ni_bool_t);
 extern int	ni_ovs_vsctl_bridge_port_del(const char *, const char *);
 extern int	ni_ovs_vsctl_bridge_port_to_bridge(const char *, char **);
 
 extern int	ni_ovs_bridge_discover(ni_netdev_t *, ni_netconfig_t *);
+extern int	ni_ovs_port_info_discover(ni_netdev_port_info_t *,
+				const char *, ni_netconfig_t *);
 
 #endif /* NI_WICKED_OVS_CTL_H */
diff --git a/src/sysconfig.c b/src/sysconfig.c
index b34979874..2aed349c8 100644
--- a/src/sysconfig.c
+++ b/src/sysconfig.c
@@ -30,22 +30,27 @@ ni_sysconfig_new(const char *pathname)
 {
 	ni_sysconfig_t *sc;
 
-	sc = calloc(1, sizeof(ni_sysconfig_t));
-	sc->pathname = xstrdup(pathname);
+	if (!(sc = calloc(1, sizeof(ni_sysconfig_t))))
+		return NULL;
 
-	return sc;
+	if (ni_string_dup(&sc->pathname, pathname))
+		return sc;
+
+	ni_sysconfig_free(sc);
+	return NULL;
 }
 
 /*
- * Destroy the sysconfig object
- * FIXME: should be called ni_sysconfig_free
+ * free the sysconfig object
  */
 void
-ni_sysconfig_destroy(ni_sysconfig_t *sc)
+ni_sysconfig_free(ni_sysconfig_t *sc)
 {
-	ni_var_array_destroy(&sc->vars);
-	ni_string_free(&sc->pathname);
-	free(sc);
+	if (sc) {
+		ni_var_array_destroy(&sc->vars);
+		ni_string_free(&sc->pathname);
+		free(sc);
+	}
 }
 
 /*
@@ -61,11 +66,16 @@ __ni_sysconfig_read(const char *filename, const char **varnames)
 
 	ni_debug_readwrite("ni_sysconfig_read(%s)", filename);
 	if (!(fp = fopen(filename, "r"))) {
-		ni_error("unable to open %s: %m", filename);
+		ni_error("unable to open sysconfig file '%s': %m", filename);
+		return NULL;
+	}
+
+	if (!(sc = ni_sysconfig_new(filename))) {
+		ni_error("unable to allocate sysconfig struct for '%s': %m", filename);
+		fclose(fp);
 		return NULL;
 	}
 
-	sc = ni_sysconfig_new(filename);
 	while (fgets(linebuf, sizeof(linebuf), fp) != NULL) {
 		char *name, *value;
 		char *sp = linebuf;
@@ -362,40 +372,45 @@ quote(char *string)
 	return quoted;
 }
 
-void
+ni_bool_t
 ni_sysconfig_set(ni_sysconfig_t *sc, const char *name, const char *value)
 {
-	ni_var_array_set(&sc->vars, name, value);
+	return sc ? ni_var_array_set(&sc->vars, name, value) : FALSE;
 }
 
-void
+ni_bool_t
 ni_sysconfig_set_integer(ni_sysconfig_t *sc, const char *name, unsigned int value)
 {
 	char buffer[32];
 
 	snprintf(buffer, sizeof(buffer), "%u", value);
-	ni_sysconfig_set(sc, name, buffer);
+	return ni_sysconfig_set(sc, name, buffer);
 }
 
-void
+ni_bool_t
 ni_sysconfig_set_boolean(ni_sysconfig_t *sc, const char *name, int value)
 {
-	ni_sysconfig_set(sc, name, value? "yes" : "no");
+	return ni_sysconfig_set(sc, name, value ? "yes" : "no");
 }
 
 ni_var_t *
 ni_sysconfig_get(const ni_sysconfig_t *sc, const char *name)
 {
-	return ni_var_array_get(&sc->vars, name);
+	return sc ? ni_var_array_get(&sc->vars, name) : NULL;
 }
 
-int
+unsigned int
 ni_sysconfig_find_matching(const ni_sysconfig_t *sc, const char *prefix,
 		ni_string_array_t *res)
 {
-	unsigned int i, pfxlen;
+	unsigned int i, count;
+	size_t pfxlen;
 	ni_var_t *var;
 
+	if (!sc || !prefix || !res)
+		return 0;
+
+	count = res->count;
 	pfxlen = strlen(prefix);
 	for (i = 0, var = sc->vars.data; i < sc->vars.count; ++i, ++var) {
 		const char *value = var->value;
@@ -403,7 +418,7 @@ ni_sysconfig_find_matching(const ni_sysconfig_t *sc, const char *prefix,
 		if (value && *value && !strncmp(var->name, prefix, pfxlen))
 			ni_string_array_append(res, var->name);
 	}
-	return res->count;
+	return res->count - count;
 }
 
 const char *
diff --git a/src/sysfs.c b/src/sysfs.c
index 32c29ef6d..a5b5a57a0 100644
--- a/src/sysfs.c
+++ b/src/sysfs.c
@@ -517,14 +517,14 @@ ni_sysfs_bridge_get_port_names(const char *ifname, ni_string_array_t *names)
 }
 
 void
-ni_sysfs_bridge_port_get_config(const char *ifname, ni_bridge_port_t *port)
+ni_sysfs_bridge_port_get_config(const char *ifname, ni_bridge_port_config_t *port)
 {
 	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/priority", &port->priority);
 	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/path_cost", &port->path_cost);
 }
 
 int
-ni_sysfs_bridge_port_update_config(const char *ifname, const ni_bridge_port_t *port)
+ni_sysfs_bridge_port_update_config(const char *ifname, const ni_bridge_port_config_t *port)
 {
 	int rv = 0;
 
@@ -539,28 +539,6 @@ ni_sysfs_bridge_port_update_config(const char *ifname, const ni_bridge_port_t *p
 	return rv;
 }
 
-void
-ni_sysfs_bridge_port_get_status(const char *ifname, ni_bridge_port_status_t *ps)
-{
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/priority", &ps->priority);
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/path_cost", &ps->path_cost);
-
-	ni_sysfs_netif_get_int(ifname, SYSFS_BRIDGE_PORT_ATTR "/state", &ps->state);
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/port_no", &ps->port_no);
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/port_id", &ps->port_no);
-	ni_sysfs_netif_get_string(ifname, SYSFS_BRIDGE_PORT_ATTR "/designated_root", &ps->designated_root);
-	ni_sysfs_netif_get_string(ifname, SYSFS_BRIDGE_PORT_ATTR "/designated_bridge", &ps->designated_bridge);
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/designated_port", &ps->designated_port);
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/designated_cost", &ps->designated_cost);
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/change_ack", &ps->change_ack);
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/hairpin_mode", &ps->hairpin_mode);
-	ni_sysfs_netif_get_uint(ifname, SYSFS_BRIDGE_PORT_ATTR "/config_pending", &ps->config_pending);
-
-	ni_sysfs_netif_get_ulong(ifname, SYSFS_BRIDGE_PORT_ATTR "/hold_timer", &ps->hold_timer);
-	ni_sysfs_netif_get_ulong(ifname, SYSFS_BRIDGE_PORT_ATTR "/message_age_timer", &ps->message_age_timer);
-	ni_sysfs_netif_get_ulong(ifname, SYSFS_BRIDGE_PORT_ATTR "/forward_delay_timer", &ps->forward_delay_timer);
-}
-
 /*
  * Get/set IPv4 sysctls
  */
diff --git a/src/sysfs.h b/src/sysfs.h
index a6457703d..f308b1c61 100644
--- a/src/sysfs.h
+++ b/src/sysfs.h
@@ -59,9 +59,8 @@ extern void	ni_sysfs_bridge_get_config(const char *, ni_bridge_t *);
 extern int	ni_sysfs_bridge_update_config(const char *, const ni_bridge_t *);
 extern void	ni_sysfs_bridge_get_status(const char *, ni_bridge_status_t *);
 extern int	ni_sysfs_bridge_get_port_names(const char *, ni_string_array_t *);
-extern void	ni_sysfs_bridge_port_get_config(const char *, ni_bridge_port_t *);
-extern int	ni_sysfs_bridge_port_update_config(const char *, const ni_bridge_port_t *);
-extern void	ni_sysfs_bridge_port_get_status(const char *, ni_bridge_port_status_t *);
+extern void	ni_sysfs_bridge_port_get_config(const char *, ni_bridge_port_config_t *);
+extern int	ni_sysfs_bridge_port_update_config(const char *, const ni_bridge_port_config_t *);
 extern ni_pci_dev_t *ni_sysfs_netdev_get_pci(const char *ifname);
 
 extern int	ni_sysctl_ipv6_ifconfig_is_present(const char *ifname);
diff --git a/src/team.c b/src/team.c
index 1451296cb..da3eec94e 100644
--- a/src/team.c
+++ b/src/team.c
@@ -1,7 +1,7 @@
 /*
- *	Team device support
+ *	Team network interface support
  *
- *	Copyright (C) 2015 SUSE Linux GmbH, Nuernberg, Germany.
+ *	Copyright (C) 2015-2023 SUSE LLC
  *
  *	This program is free software; you can redistribute it and/or modify
  *	it under the terms of the GNU General Public License as published by
@@ -13,14 +13,8 @@
  *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *	GNU General Public License for more details.
  *
- *	You should have received a copy of the GNU General Public License along
- *	with this program; if not, see <http://www.gnu.org/licenses/> or write
- *	to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
- *	Boston, MA 02110-1301 USA.
- *
- *	Authors:
- *		Pawel Wieczorkiewicz <pwieczorkiewicz@suse.de>
- *		Marius Tomaschewski <mt@suse.de>
+ *	You should have received a copy of the GNU General Public License
+ *	along with this program. If not, see <http://www.gnu.org/licenses/>.
  */
 #ifdef HAVE_CONFIG_H
 #include "config.h"
@@ -35,8 +29,6 @@
 #include "array_priv.h"
 
 #define NI_TEAM_LINK_WATCH_ARRAY_CHUNK		4
-#define NI_TEAM_PORT_ARRAY_CHUNK		4
-
 
 /*
  * Map teamd mode names to constants
@@ -223,6 +215,30 @@ ni_team_ab_hwaddr_policy_name_to_type(const char *name, ni_team_ab_hwaddr_policy
 	return TRUE;
 }
 
+void
+ni_team_runner_init(ni_team_runner_t *runner, ni_team_runner_type_t type)
+{
+	memset(runner, 0, sizeof(*runner));
+	runner->type = type;
+
+	/* apply non-zero type depending defaults here */
+	switch (runner->type) {
+	case NI_TEAM_RUNNER_ROUND_ROBIN:
+	case NI_TEAM_RUNNER_ACTIVE_BACKUP:
+	case NI_TEAM_RUNNER_LOAD_BALANCE:
+	case NI_TEAM_RUNNER_BROADCAST:
+	case NI_TEAM_RUNNER_RANDOM:
+	case NI_TEAM_RUNNER_LACP:
+	default:
+		break;
+	}
+}
+
+void
+ni_team_runner_destroy(ni_team_runner_t *runner)
+{
+}
+
 /*
  * Map teamd link watch names to constants
  */
@@ -346,61 +362,8 @@ extern ni_define_ptr_array_append(ni_team_link_watch);
 extern ni_define_ptr_array_delete_at(ni_team_link_watch);
 
 /*
- * team port
+ * team interface
  */
-ni_team_port_t *
-ni_team_port_new(void)
-{
-	ni_team_port_t *port;
-
-	port = xcalloc(1, sizeof(*port));
-	ni_team_port_config_init(&port->config);
-	return port;
-}
-
-void
-ni_team_port_free(ni_team_port_t *port)
-{
-	ni_netdev_ref_destroy(&port->device);
-	ni_team_port_config_destroy(&port->config);
-	free(port);
-}
-
-static ni_define_ptr_array_init(ni_team_port);
-extern ni_define_ptr_array_destroy(ni_team_port);
-static ni_define_ptr_array_realloc(ni_team_port, NI_TEAM_PORT_ARRAY_CHUNK);
-extern ni_define_ptr_array_append(ni_team_port);
-extern ni_define_ptr_array_delete_at(ni_team_port);
-
-extern ni_team_port_t *
-ni_team_port_array_find_by_name(ni_team_port_array_t *array, const char *name)
-{
-	unsigned int i;
-
-	if (!array || !name)
-		return NULL;
-
-	for (i = 0; i < array->count; ++i) {
-		ni_team_port_t *port = array->data[i];
-		if (ni_string_eq(name, port->device.name))
-			return port;
-	}
-	return NULL;
-}
-
-void
-ni_team_port_config_init(ni_team_port_config_t *pc)
-{
-	if (pc) {
-		pc->queue_id = -1U;
-	}
-}
-
-void
-ni_team_port_config_destroy(ni_team_port_config_t *pc)
-{
-}
-
 static void
 ni_team_init(ni_team_t *team)
 {
@@ -410,9 +373,6 @@ ni_team_init(ni_team_t *team)
 	team->mcast_rejoin.interval = -1U;
 }
 
-/*
- * team device
- */
 ni_team_t *
 ni_team_new(void)
 {
@@ -430,32 +390,102 @@ ni_team_free(ni_team_t *team)
 	if (team) {
 		ni_team_runner_destroy(&team->runner);
 		ni_team_link_watch_array_destroy(&team->link_watch);
-		ni_team_port_array_destroy(&team->ports);
 		free(team);
 	}
 }
 
+/*
+ * team port link-request configuration
+ */
+ni_bool_t
+ni_team_port_config_init(ni_team_port_config_t *conf)
+{
+	if (conf) {
+		memset(conf, 0, sizeof(*conf));
+		conf->queue_id = -1U;
+		return TRUE;
+	}
+	return FALSE;
+}
+
 void
-ni_team_runner_init(ni_team_runner_t *runner, ni_team_runner_type_t type)
+ni_team_port_config_destroy(ni_team_port_config_t *conf)
 {
-	memset(runner, 0, sizeof(*runner));
-	runner->type = type;
+	ni_team_port_config_init(conf);
+}
 
-	/* apply non-zero type depending defaults here */
+ni_team_port_config_t *
+ni_team_port_config_new(void)
+{
+	ni_team_port_config_t *conf;
+
+	conf = malloc(sizeof(*conf));
+	if (ni_team_port_config_init(conf))
+		return conf;
+
+	free(conf);
+	return NULL;
+}
+
+void
+ni_team_port_config_free(ni_team_port_config_t *conf)
+{
+	ni_team_port_config_destroy(conf);
+	free(conf);
+}
+
+/*
+ * team port interface info properties
+ */
+static ni_bool_t
+ni_team_port_info_init(ni_team_port_info_t *info)
+{
+	if (info) {
+		memset(info, 0, sizeof(*info));
+		/* apply "not set" defaults */
+		info->runner.type = -1U;
+		return TRUE;
+	}
+	return FALSE;
+}
+
+ni_team_port_info_t *
+ni_team_port_info_new(void)
+{
+	ni_team_port_info_t *info;
+
+	info = malloc(sizeof(*info));
+	if (ni_team_port_info_init(info))
+		return info;
+
+	free(info);
+	return NULL;
+}
+
+static inline void
+ni_team_port_runner_lacp_info_free(ni_team_port_runner_lacp_info_t *lacp)
+{
+	ni_string_free(&lacp->state);
+}
+
+static inline void
+ni_team_port_runner_info_free(ni_team_port_runner_info_t *runner)
+{
 	switch (runner->type) {
-	case NI_TEAM_RUNNER_ROUND_ROBIN:
-	case NI_TEAM_RUNNER_ACTIVE_BACKUP:
-	case NI_TEAM_RUNNER_LOAD_BALANCE:
-	case NI_TEAM_RUNNER_BROADCAST:
-	case NI_TEAM_RUNNER_RANDOM:
 	case NI_TEAM_RUNNER_LACP:
+		ni_team_port_runner_lacp_info_free(&runner->lacp);
+		break;
 	default:
 		break;
 	}
 }
 
 void
-ni_team_runner_destroy(ni_team_runner_t *runner)
+ni_team_port_info_free(ni_team_port_info_t *info)
 {
+	if (info) {
+		ni_team_port_runner_info_free(&info->runner);
+		free(info);
+	}
 }
 
